// CryptEclairMsg.cpp
// Copyright (C) 2007 Aquariansoft(Satoshi Akane). All rights reserved.
//
// G[͓K

#include "stdafx.h"
#include "global.h"
#include "md5.h"
#include "blowfish.h"

int encode_msg(LPSTR lpszPassword, LPTSTR lpszInputPath, LPTSTR lpszOutputPath);
int decode_msg(LPSTR lpszPassword, LPTSTR lpszInputPath, LPTSTR lpszOutputPath);

extern "C" {
void MD5String (char *string, unsigned char digest[16]);
}

/////////////////////////////////////////////////////////////////////////////

int _tmain(int argc, _TCHAR* argv[])
{
	if (argc != 5) {
		_tprintf(_T("[USAGE] CryptEclairMsg -e/d password input-file-path output-file-path\n"));
		_tprintf(_T("        (-e:encode / -d:decode)\n"));
		return 1;
	}

	if (_tcsicmp(argv[1], _T("-e")) == 0)
		return encode_msg(argv[2], argv[3], argv[4]);
	else if (_tcsicmp(argv[1], _T("-d")) == 0)
		return decode_msg(argv[2], argv[3], argv[4]);
	else {
		_tprintf(_T("Invalid option.\n"));
		return 1;
	}
}

// bZ[WÍ
int encode_msg(LPSTR lpszPassword, LPTSTR lpszInputPath, LPTSTR lpszOutputPath)
{
	// t@Cǂݍ
	HANDLE hFile = CreateFile(lpszInputPath, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		_tprintf(_T("Input file open failed.\n"));
		return 1;
	}
	DWORD dwFileSize = GetFileSize(hFile, NULL);
	if (dwFileSize == -1) {
		_tprintf(_T("Invalid input file size.\n"));
		return 1;
	}
	CBlowFish bf;
	DWORD dwInputSize = bf.GetOutputLength(sizeof(int) + dwFileSize);
	unsigned char* lpInputBuf = (unsigned char*)malloc(dwInputSize);
	ReadFile(hFile, lpInputBuf + sizeof(int), dwFileSize, &dwFileSize, NULL);
	CloseHandle(hFile);

	// 擪Ƀf[^oCgǉ
	*(int*)lpInputBuf = dwFileSize;
	// sizeof(int) + dwFileSizeȍ~̓S~

	// pX[hMD5ɂ
	UCHAR digest[16];
	MD5String(lpszPassword, digest);

	// BLOWFISH
	bf.Initialize(digest, sizeof(digest));

	// GR[h
	DWORD dwOutputSize = dwInputSize + 2;
	unsigned char* lpOutputBuf = (unsigned char*)malloc(dwOutputSize);
	bf.Encode(lpInputBuf, lpOutputBuf + 2, dwInputSize);

	// 擪CRLFǉ
	*lpOutputBuf = '\r';
	*(lpOutputBuf + 1) = '\n';

	// Íꂽf[^ۑ
	hFile = CreateFile(lpszOutputPath, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		_tprintf(_T("Output file open failed.\n"));
		free(lpInputBuf);
		free(lpOutputBuf);
		return 1;
	}
	WriteFile(hFile, lpOutputBuf, dwOutputSize, &dwOutputSize, NULL);
	CloseHandle(hFile);

	free(lpInputBuf);
	free(lpOutputBuf);
	return 0;
}

// bZ[W𕜍
int decode_msg(LPSTR lpszPassword, LPTSTR lpszInputPath, LPTSTR lpszOutputPath)
{
	// Íꂽt@Cǂݍ
	HANDLE hFile = CreateFile(lpszInputPath, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		_tprintf(_T("Input file open failed.\n"));
		return 1;
	}
	DWORD dwFileSize = GetFileSize(hFile, NULL);
	if (dwFileSize == -1) {
		_tprintf(_T("Invalid input file size.\n"));
		return 1;
	}
	unsigned char* lpInputBuf = (unsigned char*)malloc(dwFileSize);
	ReadFile(hFile, lpInputBuf, dwFileSize, &dwFileSize, NULL);
	CloseHandle(hFile);

	// 擪CRLF̂͂
	if (*lpInputBuf != '\r' || *(lpInputBuf + 1) != '\n') {
		_tprintf(_T("Invalid data (CRLF).\n"));
		free(lpInputBuf);
		return 1;
	}

	// Íf[^̃TCY`FbN
	if ((dwFileSize - 2) % 8 != 0) {
		_tprintf(_T("Invalid data (file size).\n"));
		free(lpInputBuf);
		return 1;
	}

	// pX[hMD5ɂ
	UCHAR digest[16];
	MD5String(lpszPassword, digest);

	// BLOWFISH
	CBlowFish bf;
	bf.Initialize(digest, sizeof(digest));

	// fR[h
	unsigned char* lpOutputBuf = (unsigned char*)malloc(dwFileSize - 2);
	bf.Decode(lpInputBuf + 2, lpOutputBuf, dwFileSize - 2);

	// 擪̃f[^oCg`FbNiقȂ΋炭pX[h̊ԈႢj
	DWORD dwDataBytes = *(int*)lpOutputBuf;
	if (bf.GetOutputLength(sizeof(int) + dwDataBytes) != dwFileSize - 2) {
		_tprintf(_T("Invalid data (data size). Invalid password?\n"));
		free(lpInputBuf);
		free(lpOutputBuf);
		return 1;
	}

	// ꂽf[^ۑ
	hFile = CreateFile(lpszOutputPath, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		_tprintf(_T("Output file open failed.\n"));
		free(lpInputBuf);
		free(lpOutputBuf);
		return 1;
	}
	WriteFile(hFile, lpOutputBuf + sizeof(int), dwDataBytes, &dwDataBytes, NULL);
	CloseHandle(hFile);

	free(lpInputBuf);
	free(lpOutputBuf);
	return 0;
}
